#!/bin/sh

CompilerSources()
{
	find src -name '*.c' -or -name '*.h'
}

RuntimeSources()
{
	find rtl -name '*.java' -or -name '*.obn'
}

TestsSources()
{
	find tests -name '*.obn'
}

OctaoxygenSources()
{
	find octaoxygen -name '*.obn' -or -name '*.Mod'
}

echo Compiler Sources:
wc -l $(CompilerSources)

echo
echo Runtime Library:
wc -l $(RuntimeSources)

echo
echo Tests:
wc -l $(TestsSources)

echo
echo Octaoxygen:
wc -l $(OctaoxygenSources)

echo
echo Total:
wc -l $(CompilerSources) $(RuntimeSources) $(TestsSources) $(OctaoxygenSources) | grep total
