import java.lang.Math;

public class SYSTEM
{
	/* Каркас для фреймов процедур */
	public static abstract class FRAME
	{
		public FRAME up;
	}

	/* Длинна строки LEN(s$) */
	public static int LEN(byte[] x)
	{
		int i = 0;
		while(x[i] != 0)
		{
			i += 1;
		}
		return i;
	}

	public static String STRING(byte[] x)
	{
		return new String(x, 0, LEN(x));
	}

	public static void COPY(byte[] x, byte[] v)
	{
		int ix = LEN(x);
		int iv = v.length - 1;

		int i = 0;
		int len = (ix < iv) ? (ix) : (iv);
		while(i < len)
		{
			v[i] = x[i];
			i += 1;
		}
		v[i] = 0;
	}

	public static void COPY(String x, byte[] v)
	{
		int ix = x.length();
		int iv = v.length - 1;

		int i = 0;
		int len = (ix < iv) ? (ix) : (iv);
		while(i < len)
		{
			v[i] = (byte) x.charAt(i);
			i += 1;
		}
		v[i] = 0;
	}

	public static int STRCMP(byte[] a, byte[] b)
	{
		int i = 0;
		while(a[i] != 0 && a[i] == b[i])
		{
			i += 1;
		}
		return a[i] - b[i];
	}

	public static void HALT(long n)
	{
		System.exit((int) n);
	}

	public static void ASSERT(boolean x)
	{
		assert x;
	}

	public static void ASSERT(boolean x, long n)
	{
		assert x : n;
	}

	public static void TRAP(long n)
	{
		if(n == -1)
		{
			throw new RuntimeException("CASE TRAP");
		}
		else if(n == -2)
		{
			throw new RuntimeException("WITH TRAP");
		}
		else if(n == -3)
		{
			throw new RuntimeException("NOT IMPLEMENTED");
		}
		else if(n == -4)
		{
			throw new RuntimeException("RETURN TRAP");
		}
		else
		{
			throw new RuntimeException("TRAP CODE " + n);
		}
	}

	public static int ASH(int x, int n)
	{
		return (n > 0) ? (x << n) : (x >> Math.abs(n));
	}

	public static long ASH(long x, long n)
	{
		return (n > 0) ? (x << n) : (x >> Math.abs(n));
	}

	public static int LSH(int x, int n)
	{
		return (n > 0) ? (x << n) : (x >>> Math.abs(n));
	}

	public static long LSH(long x, long n)
	{
		return (n > 0) ? (x << n) : (x >>> Math.abs(n));
	}

	public static int ROT(int x, int n)
	{
		if(n > 0)
		{
			return (x << n) | (x >>> (Integer.SIZE - n));
		}
		else
		{
			n = Math.abs(n);
			return (x >>> n) | (x << (Integer.SIZE - n));
		}
	}

	public static long ROT(long x, long n)
	{
		if(n > 0)
		{
			return (x << n) | (x >>> (Long.SIZE - n));
		}
		else
		{
			n = Math.abs(n);
			return (x >>> n) | (x << (Long.SIZE - n));
		}
	}
}
